/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 3.0.12
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package it.politecnico.coolprop;

public class CoolPropJNI {
  public final static native long new_DoubleVector__SWIG_0();
  public final static native long new_DoubleVector__SWIG_1(long jarg1);
  public final static native long DoubleVector_size(long jarg1, DoubleVector jarg1_);
  public final static native long DoubleVector_capacity(long jarg1, DoubleVector jarg1_);
  public final static native void DoubleVector_reserve(long jarg1, DoubleVector jarg1_, long jarg2);
  public final static native boolean DoubleVector_isEmpty(long jarg1, DoubleVector jarg1_);
  public final static native void DoubleVector_clear(long jarg1, DoubleVector jarg1_);
  public final static native void DoubleVector_add(long jarg1, DoubleVector jarg1_, double jarg2);
  public final static native double DoubleVector_get(long jarg1, DoubleVector jarg1_, int jarg2);
  public final static native void DoubleVector_set(long jarg1, DoubleVector jarg1_, int jarg2, double jarg3);
  public final static native void delete_DoubleVector(long jarg1);
  public final static native long new_VectorOfDoubleVector__SWIG_0();
  public final static native long new_VectorOfDoubleVector__SWIG_1(long jarg1);
  public final static native long VectorOfDoubleVector_size(long jarg1, VectorOfDoubleVector jarg1_);
  public final static native long VectorOfDoubleVector_capacity(long jarg1, VectorOfDoubleVector jarg1_);
  public final static native void VectorOfDoubleVector_reserve(long jarg1, VectorOfDoubleVector jarg1_, long jarg2);
  public final static native boolean VectorOfDoubleVector_isEmpty(long jarg1, VectorOfDoubleVector jarg1_);
  public final static native void VectorOfDoubleVector_clear(long jarg1, VectorOfDoubleVector jarg1_);
  public final static native void VectorOfDoubleVector_add(long jarg1, VectorOfDoubleVector jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long VectorOfDoubleVector_get(long jarg1, VectorOfDoubleVector jarg1_, int jarg2);
  public final static native void VectorOfDoubleVector_set(long jarg1, VectorOfDoubleVector jarg1_, int jarg2, long jarg3, DoubleVector jarg3_);
  public final static native void delete_VectorOfDoubleVector(long jarg1);
  public final static native long new_StringVector__SWIG_0();
  public final static native long new_StringVector__SWIG_1(long jarg1);
  public final static native long StringVector_size(long jarg1, StringVector jarg1_);
  public final static native long StringVector_capacity(long jarg1, StringVector jarg1_);
  public final static native void StringVector_reserve(long jarg1, StringVector jarg1_, long jarg2);
  public final static native boolean StringVector_isEmpty(long jarg1, StringVector jarg1_);
  public final static native void StringVector_clear(long jarg1, StringVector jarg1_);
  public final static native void StringVector_add(long jarg1, StringVector jarg1_, String jarg2);
  public final static native String StringVector_get(long jarg1, StringVector jarg1_, int jarg2);
  public final static native void StringVector_set(long jarg1, StringVector jarg1_, int jarg2, String jarg3);
  public final static native void delete_StringVector(long jarg1);
  public final static native long new_VectorOfStringVector__SWIG_0();
  public final static native long new_VectorOfStringVector__SWIG_1(long jarg1);
  public final static native long VectorOfStringVector_size(long jarg1, VectorOfStringVector jarg1_);
  public final static native long VectorOfStringVector_capacity(long jarg1, VectorOfStringVector jarg1_);
  public final static native void VectorOfStringVector_reserve(long jarg1, VectorOfStringVector jarg1_, long jarg2);
  public final static native boolean VectorOfStringVector_isEmpty(long jarg1, VectorOfStringVector jarg1_);
  public final static native void VectorOfStringVector_clear(long jarg1, VectorOfStringVector jarg1_);
  public final static native void VectorOfStringVector_add(long jarg1, VectorOfStringVector jarg1_, long jarg2, StringVector jarg2_);
  public final static native long VectorOfStringVector_get(long jarg1, VectorOfStringVector jarg1_, int jarg2);
  public final static native void VectorOfStringVector_set(long jarg1, VectorOfStringVector jarg1_, int jarg2, long jarg3, StringVector jarg3_);
  public final static native void delete_VectorOfStringVector(long jarg1);
  public final static native void SimpleState_rhomolar_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_rhomolar_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_T_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_T_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_p_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_p_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_hmolar_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_hmolar_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_smolar_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_smolar_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_umolar_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_umolar_get(long jarg1, SimpleState jarg1_);
  public final static native void SimpleState_Q_set(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native double SimpleState_Q_get(long jarg1, SimpleState jarg1_);
  public final static native long new_SimpleState();
  public final static native void SimpleState_fill(long jarg1, SimpleState jarg1_, double jarg2);
  public final static native boolean SimpleState_is_valid(long jarg1, SimpleState jarg1_);
  public final static native void delete_SimpleState(long jarg1);
  public final static native void CriticalState_stable_set(long jarg1, CriticalState jarg1_, boolean jarg2);
  public final static native boolean CriticalState_stable_get(long jarg1, CriticalState jarg1_);
  public final static native long new_CriticalState();
  public final static native void delete_CriticalState(long jarg1);
  public final static native int SsatSimpleState_SSAT_MAX_NOT_SET_get();
  public final static native void SsatSimpleState_exists_set(long jarg1, SsatSimpleState jarg1_, int jarg2);
  public final static native int SsatSimpleState_exists_get(long jarg1, SsatSimpleState jarg1_);
  public final static native long new_SsatSimpleState();
  public final static native void delete_SsatSimpleState(long jarg1);
  public final static native int INVALID_PARAMETER_get();
  public final static native String get_parameter_information(int jarg1, String jarg2);
  public final static native int get_parameter_index(String jarg1);
  public final static native boolean is_valid_phase(String jarg1, long jarg2);
  public final static native int get_phase_index(String jarg1);
  public final static native boolean is_trivial_parameter(int jarg1);
  public final static native boolean is_valid_parameter(String jarg1, long jarg2);
  public final static native boolean is_valid_first_derivative(String jarg1, long jarg2, long jarg3, long jarg4);
  public final static native boolean is_valid_first_saturation_derivative(String jarg1, long jarg2, long jarg3);
  public final static native boolean is_valid_second_derivative(String jarg1, long jarg2, long jarg3, long jarg4, long jarg5, long jarg6);
  public final static native String get_csv_parameter_list();
  public final static native int INPUT_PAIR_INVALID_get();
  public final static native boolean match_pair(int jarg1, int jarg2, int jarg3, int jarg4, long jarg5);
  public final static native int get_input_pair_index(String jarg1);
  public final static native String get_input_pair_short_desc(int jarg1);
  public final static native String get_input_pair_long_desc(int jarg1);
  public final static native void split_input_pair(int jarg1, long jarg2, long jarg3);
  public final static native String get_mixture_binary_pair_data(String jarg1, String jarg2, String jarg3);
  public final static native void set_mixture_binary_pair_data(String jarg1, String jarg2, String jarg3, double jarg4);
  public final static native String get_mixture_binary_pair_pcsaft(String jarg1, String jarg2, String jarg3);
  public final static native void set_mixture_binary_pair_pcsaft(String jarg1, String jarg2, String jarg3, double jarg4);
  public final static native int INVALID_BACKEND_FAMILY_get();
  public final static native int INVALID_BACKEND_get();
  public final static native void extract_backend_families(String jarg1, long jarg2, long jarg3);
  public final static native void extract_backend_families_string(String jarg1, long jarg2, long jarg3);
  public final static native String get_backend_string(int jarg1);
  public final static native void SpinodalData_tau_set(long jarg1, SpinodalData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long SpinodalData_tau_get(long jarg1, SpinodalData jarg1_);
  public final static native void SpinodalData_delta_set(long jarg1, SpinodalData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long SpinodalData_delta_get(long jarg1, SpinodalData jarg1_);
  public final static native void SpinodalData_M1_set(long jarg1, SpinodalData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long SpinodalData_M1_get(long jarg1, SpinodalData jarg1_);
  public final static native long new_SpinodalData();
  public final static native void delete_SpinodalData(long jarg1);
  public final static native void GuessesStructure_T_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_T_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_p_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_p_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_rhomolar_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_rhomolar_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_hmolar_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_hmolar_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_smolar_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_smolar_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_rhomolar_liq_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_rhomolar_liq_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_rhomolar_vap_set(long jarg1, GuessesStructure jarg1_, double jarg2);
  public final static native double GuessesStructure_rhomolar_vap_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_x_set(long jarg1, GuessesStructure jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long GuessesStructure_x_get(long jarg1, GuessesStructure jarg1_);
  public final static native void GuessesStructure_y_set(long jarg1, GuessesStructure jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long GuessesStructure_y_get(long jarg1, GuessesStructure jarg1_);
  public final static native long new_GuessesStructure();
  public final static native void GuessesStructure_clear(long jarg1, GuessesStructure jarg1_);
  public final static native void delete_GuessesStructure(long jarg1);
  public final static native void delete_AbstractState(long jarg1);
  public final static native long AbstractState_factory__SWIG_0(String jarg1, String jarg2);
  public final static native long AbstractState_factory__SWIG_1(String jarg1, long jarg2, StringVector jarg2_);
  public final static native void AbstractState_set_T(long jarg1, AbstractState jarg1_, double jarg2);
  public final static native String AbstractState_backend_name(long jarg1, AbstractState jarg1_);
  public final static native boolean AbstractState_using_mole_fractions(long jarg1, AbstractState jarg1_);
  public final static native boolean AbstractState_using_mass_fractions(long jarg1, AbstractState jarg1_);
  public final static native boolean AbstractState_using_volu_fractions(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_set_reference_stateS(long jarg1, AbstractState jarg1_, String jarg2);
  public final static native void AbstractState_set_reference_stateD(long jarg1, AbstractState jarg1_, double jarg2, double jarg3, double jarg4, double jarg5);
  public final static native void AbstractState_set_mole_fractions(long jarg1, AbstractState jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native void AbstractState_set_mass_fractions(long jarg1, AbstractState jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native void AbstractState_set_volu_fractions(long jarg1, AbstractState jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long AbstractState_mole_fractions_liquid(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_mole_fractions_vapor(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_mole_fractions(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_mass_fractions(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_update(long jarg1, AbstractState jarg1_, int jarg2, double jarg3, double jarg4);
  public final static native void AbstractState_update_with_guesses(long jarg1, AbstractState jarg1_, int jarg2, double jarg3, double jarg4, long jarg5, GuessesStructure jarg5_);
  public final static native boolean AbstractState_available_in_high_level(long jarg1, AbstractState jarg1_);
  public final static native String AbstractState_fluid_param_string(long jarg1, AbstractState jarg1_, String jarg2);
  public final static native long AbstractState_fluid_names(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_get_fluid_constant(long jarg1, AbstractState jarg1_, long jarg2, int jarg3);
  public final static native void AbstractState_set_binary_interaction_double__SWIG_0(long jarg1, AbstractState jarg1_, String jarg2, String jarg3, String jarg4, double jarg5);
  public final static native void AbstractState_set_binary_interaction_double__SWIG_1(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, String jarg4, double jarg5);
  public final static native void AbstractState_set_binary_interaction_string__SWIG_0(long jarg1, AbstractState jarg1_, String jarg2, String jarg3, String jarg4, String jarg5);
  public final static native void AbstractState_set_binary_interaction_string__SWIG_1(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, String jarg4, String jarg5);
  public final static native double AbstractState_get_binary_interaction_double__SWIG_0(long jarg1, AbstractState jarg1_, String jarg2, String jarg3, String jarg4);
  public final static native double AbstractState_get_binary_interaction_double__SWIG_1(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, String jarg4);
  public final static native String AbstractState_get_binary_interaction_string(long jarg1, AbstractState jarg1_, String jarg2, String jarg3, String jarg4);
  public final static native void AbstractState_apply_simple_mixing_rule(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, String jarg4);
  public final static native void AbstractState_set_cubic_alpha_C(long jarg1, AbstractState jarg1_, long jarg2, String jarg3, double jarg4, double jarg5, double jarg6);
  public final static native void AbstractState_set_fluid_parameter_double(long jarg1, AbstractState jarg1_, long jarg2, String jarg3, double jarg4);
  public final static native double AbstractState_get_fluid_parameter_double(long jarg1, AbstractState jarg1_, long jarg2, String jarg3);
  public final static native boolean AbstractState_clear(long jarg1, AbstractState jarg1_);
  public final static native boolean AbstractState_clear_comp_change(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_reducing_state(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_state(long jarg1, AbstractState jarg1_, String jarg2);
  public final static native double AbstractState_Tmin(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Tmax(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_pmax(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Ttriple(long jarg1, AbstractState jarg1_);
  public final static native int AbstractState_phase(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_specify_phase(long jarg1, AbstractState jarg1_, int jarg2);
  public final static native void AbstractState_unspecify_phase(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_T_critical(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_p_critical(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomolar_critical(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomass_critical(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_all_critical_points(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_build_spinodal(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_spinodal_data(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_criticality_contour_values(long jarg1, AbstractState jarg1_, long jarg2, long jarg3);
  public final static native double AbstractState_tangent_plane_distance__SWIG_0(long jarg1, AbstractState jarg1_, double jarg2, double jarg3, long jarg4, DoubleVector jarg4_, double jarg5);
  public final static native double AbstractState_tangent_plane_distance__SWIG_1(long jarg1, AbstractState jarg1_, double jarg2, double jarg3, long jarg4, DoubleVector jarg4_);
  public final static native double AbstractState_T_reducing(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomolar_reducing(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomass_reducing(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_p_triple(long jarg1, AbstractState jarg1_);
  public final static native String AbstractState_name(long jarg1, AbstractState jarg1_);
  public final static native String AbstractState_description(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dipole_moment(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_keyed_output(long jarg1, AbstractState jarg1_, int jarg2);
  public final static native double AbstractState_trivial_keyed_output(long jarg1, AbstractState jarg1_, int jarg2);
  public final static native double AbstractState_saturated_liquid_keyed_output(long jarg1, AbstractState jarg1_, int jarg2);
  public final static native double AbstractState_saturated_vapor_keyed_output(long jarg1, AbstractState jarg1_, int jarg2);
  public final static native double AbstractState_T(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_rhomass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_p(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Q(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_tau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_delta(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_molar_mass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_acentric_factor(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gas_constant(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Bvirial(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dBvirial_dT(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Cvirial(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dCvirial_dT(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_compressibility_factor(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_hmolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_hmolar_residual(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_hmass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_hmolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_hmass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_smolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_smolar_residual(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_smass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_smolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_smass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_umolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_umass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_umolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_umass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cpmolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cpmass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cp0molar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cp0mass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cvmolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_cvmass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gibbsmolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gibbsmolar_residual(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gibbsmass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gibbsmolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_gibbsmass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_helmholtzmolar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_helmholtzmass(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_helmholtzmolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_helmholtzmass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_volumemolar_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_volumemass_excess(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_speed_sound(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_isothermal_compressibility(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_isobaric_expansion_coefficient(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_isentropic_expansion_coefficient(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_fugacity_coefficient(long jarg1, AbstractState jarg1_, long jarg2);
  public final static native long AbstractState_fugacity_coefficients(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_fugacity(long jarg1, AbstractState jarg1_, long jarg2);
  public final static native double AbstractState_chemical_potential(long jarg1, AbstractState jarg1_, long jarg2);
  public final static native double AbstractState_fundamental_derivative_of_gas_dynamics(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_PIP(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_true_critical_point(long jarg1, AbstractState jarg1_, long jarg2, long jarg3);
  public final static native void AbstractState_ideal_curve(long jarg1, AbstractState jarg1_, String jarg2, long jarg3, DoubleVector jarg3_, long jarg4, DoubleVector jarg4_);
  public final static native double AbstractState_first_partial_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4);
  public final static native double AbstractState_second_partial_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4, int jarg5, int jarg6);
  public final static native double AbstractState_first_saturation_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3);
  public final static native double AbstractState_second_saturation_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4);
  public final static native double AbstractState_first_two_phase_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4);
  public final static native double AbstractState_second_two_phase_deriv(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4, int jarg5, int jarg6);
  public final static native double AbstractState_first_two_phase_deriv_splined(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4, double jarg5);
  public final static native void AbstractState_build_phase_envelope__SWIG_0(long jarg1, AbstractState jarg1_, String jarg2);
  public final static native void AbstractState_build_phase_envelope__SWIG_1(long jarg1, AbstractState jarg1_);
  public final static native long AbstractState_get_phase_envelope_data(long jarg1, AbstractState jarg1_);
  public final static native boolean AbstractState_has_melting_line(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_melting_line(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, double jarg4);
  public final static native double AbstractState_saturation_ancillary(long jarg1, AbstractState jarg1_, int jarg2, int jarg3, int jarg4, double jarg5);
  public final static native double AbstractState_viscosity(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_viscosity_contributions(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, long jarg4, long jarg5);
  public final static native double AbstractState_conductivity(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_conductivity_contributions(long jarg1, AbstractState jarg1_, long jarg2, long jarg3, long jarg4, long jarg5);
  public final static native double AbstractState_surface_tension(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_Prandtl(long jarg1, AbstractState jarg1_);
  public final static native void AbstractState_conformal_state(long jarg1, AbstractState jarg1_, String jarg2, long jarg3, long jarg4);
  public final static native void AbstractState_change_EOS(long jarg1, AbstractState jarg1_, long jarg2, String jarg3);
  public final static native double AbstractState_alpha0(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dalpha0_dDelta(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dalpha0_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alpha0_dDelta2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alpha0_dDelta_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alpha0_dTau2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alpha0_dTau3(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alpha0_dDelta_dTau2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alpha0_dDelta2_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alpha0_dDelta3(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_alphar(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dalphar_dDelta(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_dalphar_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alphar_dDelta2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alphar_dDelta_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d2alphar_dTau2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alphar_dDelta3(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alphar_dDelta2_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alphar_dDelta_dTau2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d3alphar_dTau3(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d4alphar_dDelta4(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d4alphar_dDelta3_dTau(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d4alphar_dDelta2_dTau2(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d4alphar_dDelta_dTau3(long jarg1, AbstractState jarg1_);
  public final static native double AbstractState_d4alphar_dTau4(long jarg1, AbstractState jarg1_);
  public final static native long AbstractStateGenerator_get_AbstractState(long jarg1, AbstractStateGenerator jarg1_, long jarg2, StringVector jarg2_);
  public final static native void delete_AbstractStateGenerator(long jarg1);
  public final static native void register_backend(int jarg1, long jarg2);
  public final static native double Props1SI(String jarg1, String jarg2);
  public final static native double PropsSI(String jarg1, String jarg2, double jarg3, String jarg4, double jarg5, String jarg6);
  public final static native long PropsSImulti(long jarg1, StringVector jarg1_, String jarg2, long jarg3, DoubleVector jarg3_, String jarg4, long jarg5, DoubleVector jarg5_, String jarg6, long jarg7, StringVector jarg7_, long jarg8, DoubleVector jarg8_);
  public final static native int get_debug_level();
  public final static native void set_debug_level(int jarg1);
  public final static native void set_error_string(String jarg1);
  public final static native void set_warning_string(String jarg1);
  public final static native double saturation_ancillary(String jarg1, String jarg2, int jarg3, String jarg4, double jarg5);
  public final static native String get_global_param_string(String jarg1);
  public final static native String get_fluid_param_string(String jarg1, String jarg2);
  public final static native boolean is_valid_fluid_string(String jarg1);
  public final static native boolean add_fluids_as_JSON(String jarg1, String jarg2);
  public final static native void set_reference_stateS(String jarg1, String jarg2);
  public final static native void set_reference_stateD(String jarg1, double jarg2, double jarg3, double jarg4, double jarg5);
  public final static native String PhaseSI(String jarg1, double jarg2, String jarg3, double jarg4, String jarg5);
  public final static native void extract_backend(String jarg1, long jarg2, long jarg3);
  public final static native String extract_fractions(String jarg1, long jarg2, DoubleVector jarg2_);
  public final static native String phase_lookup_string(int jarg1);
  public final static native void PhaseEnvelopeData_TypeI_set(long jarg1, PhaseEnvelopeData jarg1_, boolean jarg2);
  public final static native boolean PhaseEnvelopeData_TypeI_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_built_set(long jarg1, PhaseEnvelopeData jarg1_, boolean jarg2);
  public final static native boolean PhaseEnvelopeData_built_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_iTsat_max_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2);
  public final static native long PhaseEnvelopeData_iTsat_max_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_ipsat_max_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2);
  public final static native long PhaseEnvelopeData_ipsat_max_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_icrit_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2);
  public final static native long PhaseEnvelopeData_icrit_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_T_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_T_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_p_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_p_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_lnT_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_lnT_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_lnp_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_lnp_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_rhomolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_rhomolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_rhomolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_rhomolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_lnrhomolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_lnrhomolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_lnrhomolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_lnrhomolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_hmolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_hmolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_hmolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_hmolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_smolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_smolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_smolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_smolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_Q_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_Q_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_cpmolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_cpmolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_cpmolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_cpmolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_cvmolar_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_cvmolar_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_cvmolar_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_cvmolar_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_viscosity_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_viscosity_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_viscosity_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_viscosity_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_conductivity_liq_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_conductivity_liq_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_conductivity_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_conductivity_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_speed_sound_vap_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, DoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_speed_sound_vap_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_K_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, VectorOfDoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_K_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_lnK_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, VectorOfDoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_lnK_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_x_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, VectorOfDoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_x_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_y_set(long jarg1, PhaseEnvelopeData jarg1_, long jarg2, VectorOfDoubleVector jarg2_);
  public final static native long PhaseEnvelopeData_y_get(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native long new_PhaseEnvelopeData();
  public final static native void PhaseEnvelopeData_resize(long jarg1, PhaseEnvelopeData jarg1_, long jarg2);
  public final static native void PhaseEnvelopeData_clear(long jarg1, PhaseEnvelopeData jarg1_);
  public final static native void PhaseEnvelopeData_insert_variables(long jarg1, PhaseEnvelopeData jarg1_, double jarg2, double jarg3, double jarg4, double jarg5, double jarg6, double jarg7, double jarg8, double jarg9, long jarg10, long jarg11, long jarg12);
  public final static native void PhaseEnvelopeData_store_variables(long jarg1, PhaseEnvelopeData jarg1_, double jarg2, double jarg3, double jarg4, double jarg5, double jarg6, double jarg7, double jarg8, double jarg9, long jarg10, long jarg11);
  public final static native void delete_PhaseEnvelopeData(long jarg1);
  public final static native int CONFIGURATION_NOT_DEFINED_TYPE_get();
  public final static native String config_key_to_string(int jarg1);
  public final static native int config_string_to_key(String jarg1);
  public final static native String config_key_description__SWIG_0(int jarg1);
  public final static native String config_key_description__SWIG_1(String jarg1);
  public final static native long new_ConfigurationItem__SWIG_0(int jarg1, boolean jarg2);
  public final static native long new_ConfigurationItem__SWIG_1(int jarg1, int jarg2);
  public final static native long new_ConfigurationItem__SWIG_2(int jarg1, double jarg2);
  public final static native long new_ConfigurationItem__SWIG_3(int jarg1, String jarg2);
  public final static native void ConfigurationItem_set_bool(long jarg1, ConfigurationItem jarg1_, boolean jarg2);
  public final static native void ConfigurationItem_set_integer(long jarg1, ConfigurationItem jarg1_, int jarg2);
  public final static native void ConfigurationItem_set_double(long jarg1, ConfigurationItem jarg1_, double jarg2);
  public final static native void ConfigurationItem_set_string(long jarg1, ConfigurationItem jarg1_, String jarg2);
  public final static native int ConfigurationItem_get_key(long jarg1, ConfigurationItem jarg1_);
  public final static native void delete_ConfigurationItem(long jarg1);
  public final static native long new_Configuration();
  public final static native void delete_Configuration(long jarg1);
  public final static native long Configuration_get_item(long jarg1, Configuration jarg1_, int jarg2);
  public final static native void Configuration_add_item(long jarg1, Configuration jarg1_, long jarg2, ConfigurationItem jarg2_);
  public final static native long Configuration_get_items(long jarg1, Configuration jarg1_);
  public final static native void Configuration_set_defaults(long jarg1, Configuration jarg1_);
  public final static native boolean get_config_bool(int jarg1);
  public final static native int get_config_int(int jarg1);
  public final static native double get_config_double(int jarg1);
  public final static native String get_config_string(int jarg1);
  public final static native String get_config_as_json_string();
  public final static native void set_config_bool(int jarg1, boolean jarg2);
  public final static native void set_config_int(int jarg1, int jarg2);
  public final static native void set_config_double(int jarg1, double jarg2);
  public final static native void set_config_string(int jarg1, String jarg2);
  public final static native void set_config_as_json_string(String jarg1);
  public final static native double HAPropsSI(String jarg1, String jarg2, double jarg3, String jarg4, double jarg5, String jarg6, double jarg7);
  public final static native double HAProps(String jarg1, String jarg2, double jarg3, String jarg4, double jarg5, String jarg6, double jarg7);
  public final static native double HAProps_Aux(String jarg1, double jarg2, double jarg3, double jarg4, String jarg5);
  public final static native double IceProps(String jarg1, double jarg2, double jarg3);
  public final static native void UseVirialCorrelations(int jarg1);
  public final static native void UseIsothermCompressCorrelation(int jarg1);
  public final static native void UseIdealGasEnthalpyCorrelations(int jarg1);
  public final static native void HAHelp();
  public final static native int returnHumAirCode(String jarg1);
  public final static native double cair_sat(double jarg1);
  public final static native long CriticalState_SWIGUpcast(long jarg1);
  public final static native long SsatSimpleState_SWIGUpcast(long jarg1);
}
